#ifndef FUSETHREAD_H
#define FUSETHREAD_H

#include <QThread>

#define FUSE_USE_VERSION 26
#define _FILE_OFFSET_BITS 64

#include <fuse.h>

class FuseThread : public QThread
{
	Q_OBJECT
public:
	static struct fuse_operations ops;
	static const char *hello_str;
	static const char *hello_path;

	explicit FuseThread(QObject *parent = 0);

	static int getattr(const char *path, struct stat *stbuf);
	static int readdir(const char *path, void *buf, fuse_fill_dir_t filler, off_t offset, struct fuse_file_info *fi);
	static int open(const char *path, struct fuse_file_info *fi);
	static int read(const char *path, char *buf, size_t size, off_t offset, struct fuse_file_info *fi);

protected:
	void run();
	
signals:
	
public slots:
	
};

#endif // FUSETHREAD_H
